/* Trabalho de Linguagem de Programacao I
Programa Campo Minado para Unix
Alunos: Daniel Bora    - 754277
        Roberto Amorim - 754439
Professor: Robson Linhares */

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <curses.h>

//Declaramos as funcoes que serao usadas no jogo
int Jogo ( int, int, int );
int Limpa ( int linhas, int colunas, int posl, int posc, int marcacoes, char Mapa_jog[linhas][colunas], short Mapa_esc[linhas][colunas] );

/* Funcao main: apenas faz perguntas ao usuario
	Recebe: nada
	Retorna: status de saida */
int main ( void )
{
	int linhas, colunas, minas, highscore = 0, flag = 0, jogadas = 0, pontuacao = 0, escolha;
	//Contador para varias funcoes do curses:
	int curi = 3;
	//Iniciamos o curses
	initscr();
	//O programa termina se nao houver disponibilidade de cores no terminal
	if(has_colors() == FALSE)
	{
		endwin();
		printf("O seu terminal nao suporta cores!\n");
		exit(1);
	}
	start_color();
	//Os pares de cores que usamos
	init_pair(1, COLOR_RED, COLOR_WHITE);
   init_pair(2, COLOR_YELLOW, COLOR_BLUE);
	init_pair(3, COLOR_WHITE, COLOR_BLACK);
	init_pair(4, COLOR_GREEN, COLOR_BLUE);
	raw();
	echo();
	curs_set(1);
	attron(COLOR_PAIR(3));
	refresh();
	do {
		//Se ja foi feita uma jogada, mostramos a situacao do jogo e perguntamos ao jogador 
		//se ele quer continuar 
		if ( jogadas > 0 )
		{
			//Iniciamos o curses de novo, para quando voltamos da funo de jogo
			initscr();
			clear();
			halfdelay(250);
			curs_set(1);
			attron(COLOR_PAIR(3));
			refresh();
			flag = 0;
			mvprintw( 1, 1, "A sua pontuacao na ultima partida foi %i", pontuacao );
			mvprintw( 2, 1, "A maior pontuacao nessa rodada foi %i", highscore );
			mvprintw( 3, 1, "Ja houveram %i jogos nessa rodada", jogadas);
			do {
				mvprintw( 6, 1, "Voce deseja:" );
				mvprintw( 7, 1, "	1 - Jogar outra partida" );
				mvprintw( 8, 1, "	2 - Sair do jogo\n	? " );
				refresh();
				escolha = getch();
				if ( escolha == '1' )
					flag = 1;
				else if ( escolha == '2' || escolha == 'q' )
					{
						endwin();
						exit(0);
					}
				else
					mvprintw( 10, 1, "Escolha invalida. Selecione 1 ou 2" );
			} while ( flag == 0 );
			refresh();
			curi = 12;
		}
		flag = 0;
		//Vamos comecar recolhendo valores desejados pelo usuario para definir a dificuldade do jogo
		//Todos os valores sao testados para checar se estao dentro da variacao determinada
		do {
			mvprintw( curi, 1, "Quantas linhas deve ter o campo? (10 - 20) ");
			scanw("%i", &linhas);
			if ( linhas < 10 || linhas > 20 )
				mvprintw( curi-1, 1, "Quantidade invalida de linhas! Selecione um valor entre 10 e 20.");
			else
				flag = 1;
			refresh();
		} while ( flag == 0 );
		flag = 0;
		do {
			mvprintw( curi+3, 1, "Quantas colunas deve ter o campo? (10 - 40) ");
			scanw("%i", &colunas);
			if ( colunas < 10 || colunas > 40 )
				mvprintw( curi+2, 1, "Quantidade invalida de colunas! Selecione um valor entre 10 e 40.");
			else
				flag = 1;
			refresh();
		} while ( flag == 0 );
		flag = 0;
		do {
			mvprintw( curi+6, 1, "Quantas minas devem ser espalhadas pelo campo? (10 - 100) ");
			scanw("%i", &minas);
			if ( minas < 10 || minas > 100 )
				mvprintw( curi+5, 1, "Quantidade invalida de minas! Selecione um valor entre 10 e 100.");
			else
				flag = 1;
			refresh();
		} while ( flag == 0 );
		attroff(COLOR_PAIR(3));
		//Limpamos a tela e encerramos-a, ela sera reaberta dentro da funcao
		clear();
		endwin();
		//Agora que recolhemos suficientes dados, comecamos com o jogo propriamente dito
		pontuacao = Jogo( linhas, colunas, minas );
		//Armazenamos a maior pontuacao nessa rodada (isto eh, desde que o programa foi iniciado)
		if ( pontuacao > highscore ) 
			highscore = pontuacao;
		//Tambem contamos quantos jogos foram iniciados nessa rodada
		jogadas++;
	} while ( jogadas != -1 );
	return EXIT_SUCCESS;
}
/*********************************************************************************************/
/* Funcao Jogo: funcao principal que monta o tabuleiro e mostra o jogo
	Recebe: linhas, colunas e minas a serem espalhadas pelo tabuleiro
	Retorna: pontuacao do jogador (em segundos restantes no timer) */
int Jogo( int linhas, int colunas, int minas )
{
	//Criamos as tabelas que conterao os tabuleiros
	char Mapa_jog[linhas+2][colunas+2], key;
	short Mapa_esc[linhas+2][colunas+2];
	//Um monte de variaveis e flags e contadores:
	int i, j, k, l, m, marcacoes = 0, mina = 0, marcacao = 0, contamina=0;
	int posl = 1, posc = 2, flag = 0, flagcont, timer, score;
	//Tempo para o contador do score e a random seed
	time_t t, seconds, seconds2;
	srand ((unsigned) time(&t));
	//Iniciamos a tela de novo
	initscr();
	curs_set(0);
	//Primeiro, zeramos os dois tabuleiros
	for ( i = 0; i < linhas+2; i++ )
		for ( j = 0; j < colunas+2; j++ )
			Mapa_esc[i][j] = 0;
	for ( i = 0; i < linhas+2; i++ )
		for ( j = 0; j < colunas+2; j++ )
			Mapa_jog[i][j] = '.';
	//Agora, distribuimos minas pelo mapa escondido
	i = 0;
	do {
		posl = ( rand() % linhas ) + 1;
		posc = ( rand() % colunas ) + 1;
		//Antes de atribuir uma mina a uma celula, checamos se ja nao existe uma mina la
		if ( Mapa_esc[posl][posc] != 9) 
		{
			Mapa_esc[posl][posc] = 9;
			i++;
		}
	} while ( i < minas );
	posl = 1;
	posc = 2;
	//Distribuiremos os numeros de guia ao redor de cada mina
	for ( i = 1; i < linhas+1; i++ )
	{
		for ( j = 1; j < colunas+1; j++ )
		{
			m = 0;
			//Se ja ouver uma mina naquela celula, nao ha contagem
			if ( Mapa_esc[i][j] != 9 )
			{
				for ( k = i - 1; k < i + 2; k++ )
				{
					for ( l = j - 1; l < j + 2; l++ )
					{
						//Para cada mina ao redor de uma celula, incrementamos o contador
						if ( Mapa_esc[k][l] == 9 )
							m++;
					}
				}
				Mapa_esc[i][j] = m;
			}
		}
	} 
	//Usamos o score inicial como sendo a metade de linhas mais a metade de colunas
	//multiplicado pela quantidade de minas
	//Ele eh decrementado a cada segundo que passa
	timer = ((linhas/2) + (colunas/2)) * minas;
	seconds = time (NULL);
	//Imprimimos o mapa do usuario e esperamos que ele use uma tecla. Aqui comeca o jogo. 
	//Seja o que Deus quiser
	do {
skip:
		clear();
		refresh();
		attron(COLOR_PAIR(3));
		//Imprimimos o tabuleiro
		for ( i = 1; i < linhas+1; i++ )
		{
			for ( j = 1; j < colunas+1; j++ )
			{
				mvprintw( i, (j*2)-1, " " );
				mvprintw( i, j*2, "%c", Mapa_jog[i][j]);
			}
		}
		//Implementacao do timer/score
		//tomamos cuidado para nao deixar o score ficar negativo
		seconds2 = time (NULL);
		if ( (timer - ( seconds2 - seconds )) > 0 )
			score = timer - ( seconds2 - seconds );
		else
			score = 0;
		refresh();
		attroff(COLOR_PAIR(3));
		//Mostra a posicao do cursor no tabuleiro
		attron(COLOR_PAIR(4));
		mvprintw( posl, posc, "%c", Mapa_jog[posl][posc/2] );
		attroff(COLOR_PAIR(4));
		//Mostra estatisticas do jogo (minas, minas marcadas, pontuacao), tudo muito
		//colorido e bonito
		attron(COLOR_PAIR(3));
		mvprintw( 3, (colunas * 2) + 5, "Minas em jogo:");
		attroff(COLOR_PAIR(3));
		attron(COLOR_PAIR(2));
		mvprintw( 3, (colunas * 2) + 20, "%i", minas );
		attroff(COLOR_PAIR(2));
		attron(COLOR_PAIR(3));
		mvprintw( 5, (colunas * 2) + 5, "Minas marcadas:");
		attroff(COLOR_PAIR(3));
		attron(COLOR_PAIR(2));
		mvprintw( 5, (colunas * 2) + 21, "%i", marcacoes );
		attroff(COLOR_PAIR(2));
		attron(COLOR_PAIR(3));
		mvprintw( 7, (colunas * 2) + 5, "Pontuacao:");
		attroff(COLOR_PAIR(3));
		attron(COLOR_PAIR(1));
		mvprintw( 7, (colunas * 2) + 16, "%i", score );
		attroff(COLOR_PAIR(1));
		attron(COLOR_PAIR(3));
		//Antes de mais nada testa a cada laco de repeticao se o jogador marcou todas 
		//as minas corretamente, caso positivo termina o jogo dando uma mensagem de vitoria
		if ( contamina == minas )
		{
			mvprintw( linhas+4, 1, "VOCE VENCEU!!!" );
			mvprintw( linhas+6, 1, "Pressione qualquer tecla para continuar..." );
			refresh();
			//Espera 20 segundos, se o usurio no faz nada nesse meio tempo, volta para a tela
			//inicial
			halfdelay(200);
			getch();
			break;
		}
		//Testa se ainda existe casa pra jogar sem mina, e caso todas as casas sem minas 
		//tenham sido marcadas mostra uma mensagem de vitoria
		flagcont = 0;
		for ( i = 1; i < linhas+1; i++ )
			for ( j = 1; j < colunas+1; j++ )
				if ((Mapa_esc[i][j] < 9) && ((Mapa_jog[i][j] == '.') || (Mapa_jog[i][j] == 'M')))
					flagcont=1;
		if (flagcont == 0)
		{
			mvprintw( linhas+4, 1, "VOCE VENCEU!!!" );
			mvprintw( linhas+6, 1, "Pressione qualquer tecla para continuar..." );
			refresh();
			//Espera 20 segundos, se o usurio no faz nada nesse meio tempo, volta para a tela
			//inicial
			halfdelay(200);
			getch();
			break;
		}
		//Imprimimos as instrucoes de jogo
		if ( mina == 0 && marcacao == 0)
		{
			mvprintw( linhas+3, 1, "Use as teclas direcionais para circular pelo tabuleiro" );
			mvprintw( linhas+4, 1, "Use a tecla de espaco para abrir uma casa" );
			mvprintw( linhas+5, 1, "Use a tecla \"m\" para marcar uma casa como minada" );
			mvprintw( linhas+6, 1, "Use a tecla \".\" para desmarcar uma casa marcada como minada" );
			/* Usamos a tecla q ao inves da tecla ESC para abandono do jogo por que, nos varios
			ambientes de desenvolvimento que trabalhamos, nao encontramos um unico em que o curses
			levasse em consideracao a variavel de ambiente ESCDELAY. Isso impossibilitaria o uso das
			teclas direcionais do teclado para circular pelo tabuleiro. Depois de cuidadosa 
			consideracao, os programadores decidiram que abrir mao da tecla ESC comprometeria menos
			a qualidade do programa do que abrir mao das teclas direcionais. */
			mvprintw( linhas+8, 1, "Use a tecla \"q\" para abandonar o jogo" );
		}
		//Se foi gravada a flag indicando que o jogador acertou uma mina, mostra a mensagem
		//e sai do loop
		else if ( mina == 1 )
		{
			mvprintw( 7, (colunas * 2) + 5, "Pontuacao: 0000" );
			mvprintw( linhas+4, 1, "Voce explodiu uma mina!!!" );
			mvprintw( linhas+6, 1, "Pressione qualquer tecla para continuar..." );
			refresh();
			//Espera 20 segundos, se o usurio no faz nada nesse meio tempo, volta para a tela
			//inicial
			halfdelay(200);
			getch();
			break;
		}
		//Se o usuario tentar marcar mais casas como se contivessem minas do que a quantidade
		//de minas no jogo, mostra uma mensagem de erro
		else if ( marcacao == 1 )
		{
			mvprintw( linhas+4, 1, "Voce nao pode marcar mais casas do que a quantidade de minas em jogo" );
			mvprintw( linhas+5, 1, "Pressione qualquer tecla para continuar..." );
			refresh();
			//Espera 20 segundos, se o usurio no faz nada nesse meio tempo, volta para o jogo
			halfdelay(200);
			getch();
			marcacao = 0;
			//Egad! O pavor de academicos do mundo inteiro: goto!!!!
			goto skip;
		}
		attroff(COLOR_PAIR(3));
		refresh();
		//Isso garante que a tela seja atualizada pelo menos uma vez a cada segundo
		halfdelay(10);
		//Finalmente pegamos o input do usurio
		key=wgetch(stdscr);
		//Caso o usuario use uma das teclas direcionais, altera a posicao x/y do cursor
		if ( ( key == 65 ) && ( posl > 1 ) )
		{
			posl--;
		} 
		if ( ( key == 66 ) && ( posl < linhas ) )
		{
			posl++;
		} 
		if ( ( key == 67 ) && ( posc < colunas * 2 ) )
		{
			posc = posc + 2;
		} 
		if ( ( key == 68 ) && ( posc > 3 ) )
		{
			posc = posc - 2;
		} 
		if ( key == 'm' )
		{
			//Voce nao deve marcar mais casas do que a quantidade de minas em jogo...
			if ( marcacoes >= minas )
				marcacao = 1;
			//Voce nao pode marcar uma casa ja aberta
			else if ( Mapa_jog[posl][posc/2] != '.' );
			//So aumenta o contador de marcacoes se aquela casa ja nao estiver marcada
			//caso tenha marcado uma mina certo aumenta um contador que ficara escondido
			else if ( Mapa_jog[posl][posc/2] != 'M' )
			{
				Mapa_jog[posl][posc/2] = 'M';
				marcacoes++;
				if ( Mapa_jog[posl][posc/2] == 'M' && Mapa_esc[posl][posc/2] == 9 )
					contamina++;
			}
		}
		if ( key == '.' )
		{
			//So decrementa o contador de marcacoes se aquela casa estiver marcada
			//caso tenha desmarcado uma mina certa decrementa um marcador que ficara escondido
			if ( Mapa_jog[posl][posc/2] == 'M' )
			{
				if (Mapa_jog[posl][posc/2] == 'M' && Mapa_esc[posl][posc/2] == 9)
					contamina--;
				Mapa_jog[posl][posc/2] = '.';
				marcacoes--;
			}
		}
		//A fucao que abre casas. fortes emocoes!
		if ( key == ' ' && Mapa_jog[posl][posc/2] != 'M' )
		{
			//Se a casa tem uma mina, mostra todas as minas do tabuleiro e grava uma flag que
			//indica ao programa que essa partida acabou
			if ( Mapa_esc[posl][posc/2] == 9 )
			{
				for ( i = 1; i < linhas+1; i++ )
					for ( j = 1; j < colunas+1; j++ )
						if (Mapa_esc[i][j] == 9)
							Mapa_jog[i][j] = 'X';
				mina = 1;
			}
			//Se a casa tem um numero de guia, ela eh aberta isoladamente
			if ( Mapa_esc[posl][posc/2] < 9 && Mapa_esc[posl][posc/2] > 0 )
			{
				switch (Mapa_esc[posl][posc/2])
				{
					case 1:
						Mapa_jog[posl][posc/2] = '1';
						break;
					case 2:
						Mapa_jog[posl][posc/2] = '2';
						break;
					case 3:
						Mapa_jog[posl][posc/2] = '3';
						break;
					case 4:
						Mapa_jog[posl][posc/2] = '4';
						break;
					case 5:
						Mapa_jog[posl][posc/2] = '5';
						break;
					case 6:
						Mapa_jog[posl][posc/2] = '6';
						break;
					case 7:
						Mapa_jog[posl][posc/2] = '7';
						break;
					case 8:
						Mapa_jog[posl][posc/2] = '8';
						break;
				}
				mvprintw( posl, posc, "%c", Mapa_jog[posl][posc/2] );
				refresh();
			}
			//Se a casa tem um zero, abrimos casas vizinhas recursivamente
			if ( Mapa_esc[posl][posc/2] == 0 )
			{
				//Tambm testamos se aquela casa j no foi aberta...
				if ( Mapa_jog[posl][posc/2] != ' ' )
					marcacoes = Limpa( linhas, colunas, posl, posc/2, marcacoes, Mapa_jog, Mapa_esc);
			}
		}
		//O loop continua rodando alegremente enquanto a tecla q nao for usada
	} while( key != 'q' );
	clear();
	endwin();
	//Se foi acertada uma mina ou a partida foi encerrada prematuramente,
	//retorna a pontuacao 0 para a funcao principal
	if ( mina == 1 || key == 'q')
		return 0;
	//Senao, retorna a pontuacao do timer
	else
		return score;
}
/**********************************************************************/
/* Funcao Limpa: mostra todas as casas contiguas que estiverem em branco
	Recebe: linhas, colunas, posicao do cursor, minas marcadas, tabuleiro do jogador, tabuleiro escondido
	Retorna: o valor de marcacoes, depois de descontar marcacoes que por ventura estavam
	colocadas sobre celulas em branco ou celulas numeradas
	os tabuleiros nao sao retornados por terem sido passados como ponteiros */
int Limpa ( int linhas, int colunas, int posl, int posc, int marcacoes, char Mapa_jog[linhas+2][colunas+2], short Mapa_esc[linhas+2][colunas+2] )
{
	short i, j;
	for ( i = posl-1; i <= posl+1; i++ )
	{
		for ( j = posc-1; j <= posc+1; j++ )
		{
			//Se o contador tentar ultrapassar os limites do tabuleiro, pula o switch
			if ( j > colunas || j < 1 );
			else if ( i > linhas || i < 1 );
			//Se a celula sendo testada for menor que 9 (mina) e nao estiver testada
			//ainda, faz um switch para mostrar os valores do tabuleiro escondido no
			//tabuleiro do jogador
			else if ( Mapa_esc[i][j] < 9 && Mapa_jog[i][j] != ' ' )
			{
				//Tem gente que gosta de fazer roleta russa com o marcador de minas. Isso
				//aqui garante que o contador sera decrementado quando esses marcadores
				//forem apagados
				if ( Mapa_jog[i][j] == 'M' )
					marcacoes--;
				switch ( Mapa_esc[i][j] )
				{
					case 0:
						Mapa_jog[i][j] = ' ';
						//se acha um casa vazia, chama a funcao recursivamente para testar
						//os arredores dela
						marcacoes = Limpa( linhas, colunas, i, j, marcacoes, Mapa_jog, Mapa_esc);
						break;
					//se for uma das casas numeradas, apenas mostra o seu valor no tabuleiro
					//do jogador
					case 1:
						Mapa_jog[i][j] = '1';
						break;
					case 2:
						Mapa_jog[i][j] = '2';
						break;
					case 3:
						Mapa_jog[i][j] = '3';
						break;
					case 4:
						Mapa_jog[i][j] = '4';
						break;
					case 5:
						Mapa_jog[i][j] = '5';
						break;
					case 6:
						Mapa_jog[i][j] = '6';
						break;
					case 7:
						Mapa_jog[i][j] = '7';
						break;
					case 8:
						Mapa_jog[i][j] = '8';
						break;
				}
			}
		}
	}
	//Retorna o valor das marcacoes de minas depois de ser recalculado
	return marcacoes;
}

